
#include <stdio.h>
#include "cell.h"
#include "rif_rgb.h"

extern void	Error(),RangeList();

int	main(argc,argv)
int	argc;
char	**argv;
{
	int	Nx,Ny,BPS,x1,y1,x2,y2,y,x;
	Cell	**R,**G,**B;
	char	r[256],g[256],b[256];
	double	ratio;

	if (argc!=5)
	    Error("usage : area_RGB TIFF rangeListR rangeListG rangeListB");

	ReadImageFile_RGB(argv[1],&Nx,&Ny,&BPS,&R,&G,&B,NULL);

	RangeList(argv[2],(size_t)255,r);
	RangeList(argv[3],(size_t)255,g);
	RangeList(argv[4],(size_t)255,b);

	ratio=255.0/(double)((1<<BPS)-1);

	x1=Nx; y1=Ny; x2=y2=(-1);
	for (y=0; y<Ny; y++) for (x=0; x<Nx; x++)
#ifdef	NBG
	    if (!r[(int)(ratio*(double)R[y][x]+0.5)] ||
		!g[(int)(ratio*(double)G[y][x]+0.5)] ||
		!b[(int)(ratio*(double)B[y][x]+0.5)])
#else
	    if (r[(int)(ratio*(double)R[y][x]+0.5)] &&
		g[(int)(ratio*(double)G[y][x]+0.5)] &&
		b[(int)(ratio*(double)B[y][x]+0.5)])
#endif
	    {
		if (x<x1) x1=x; if (x>x2) x2=x;
		if (y<y1) y1=y; if (y>y2) y2=y;
	    }

	if (x1>x2 || y1>y2) Error("no object area.");

	(void)printf("%d\t%d\t%d\t%d\n",x1,y1,x2,y2);

	return 0;
}
