
#include <stdio.h>
#include "cell.h"
#include "rif.h"

extern void	Error(),RangeList();

#define PV	(size_t)(Cell)(~0)

int	main(argc,argv)
int	argc;
char	**argv;
{
	int	Nx,Ny,x1,y1,x2,y2,y,x;
	Cell	**cell;
	char	pv[PV+1];

	if (argc!=3) Error("usage : area_gray TIFF rangeList");

	ReadImageFile(argv[1],&Nx,&Ny,NULL,&cell,NULL);

	RangeList(argv[2],PV,pv);

	x1=Nx; y1=Ny; x2=y2=(-1);
	for (y=0; y<Ny; y++) for (x=0; x<Nx; x++)
	    if (pv[cell[y][x]]) {
		if (x<x1) x1=x; if (x>x2) x2=x;
		if (y<y1) y1=y; if (y>y2) y2=y;
	    }

	if (x1>x2 || y1>y2) Error("no object area.");

	(void)printf("%d\t%d\t%d\t%d\n",x1,y1,x2,y2);

	return 0;
}
