
#include <stdio.h>
#include <stdlib.h>
#include "cell.h"
#include "csi.h"

extern void	Error(),RangeList(),ReadSliceImage();

#define PV	(size_t)(Cell)(~0)

int	main(argc,argv)
int	argc;
char	**argv;
{
	char	**path,pv[PV+1];
	int	Nx,Ny,Nz,x1,y1,z1,x2,y2,z2,y,z,x;
	Cell	**cell;

	if (argc!=4) Error("usage : si_area directory nameFile rangeList");

	path=CheckSliceImages(argv[1],argv[2],&Nx,&Ny,&Nz,NULL);

	RangeList(argv[3],PV,pv);

	if ((cell=(Cell **)malloc(sizeof(Cell *)*(size_t)Ny))==NULL ||
	    (*cell=(Cell *)malloc(sizeof(Cell)*(size_t)Ny*(size_t)Nx))==NULL)
	    Error("no allocatable memory for cell.");

	for (y=1; y<Ny; y++) cell[y]=cell[y-1]+Nx;

	x1=Nx; y1=Ny; z1=Nz; x2=y2=z2=(-1);
	for (z=0; z<Nz; z++) {
	    ReadSliceImage(path[z],Nx,Ny,cell);

	    for (y=0; y<Ny; y++) for (x=0; x<Nx; x++)
		if (pv[cell[y][x]]) {
		    if (x<x1) x1=x; if (x>x2) x2=x;
		    if (y<y1) y1=y; if (y>y2) y2=y;
		    if (z<z1) z1=z; if (z>z2) z2=z;
		}
	}
	if (x1>x2 || y1>y2 || z1>z2) Error("no object area.");

	(void)printf("%d\t%d\t%d\t%d\t%d\t%d\n",x1,y1,z1,x2,y2,z2);

	return 0;
}
