
#include <stdio.h>
#include <stdlib.h>
#include "cell.h"
#include "csi.h"
#include "sif.h"

extern void	Error(char *msg),
		ReadSliceImage(char *path,int Nx,int Ny,Cell **slice);

#define LEN	1024

int	main(int argc,char **argv)
{
	char	**paths,line[LEN],dir[LEN],form[LEN],path[LEN];
	int	Nx,Ny,Nz,z,y,x1,y1,z1,x2,y2,z2,w,v,x;
	Cell	***O,**C;

	if (argc!=3) Error("usage : si_cut orgDir nameFile");

	paths=CheckSliceImages(argv[1],argv[2],&Nx,&Ny,&Nz,NULL);

	if ((O=(Cell ***)malloc(sizeof(Cell **)*(size_t)Nz))==NULL ||
	    (*O=(Cell **)malloc(sizeof(Cell *)*(size_t)Nz*Ny))==NULL ||
	    (**O=(Cell *)malloc(sizeof(Cell)*(size_t)Nz*Ny*Nx))==NULL ||
	    (C=(Cell **)malloc(sizeof(Cell *)*(size_t)Ny))==NULL)
	    Error("memory allocation error.");

	for (z=0; z<Nz; z++) {
	    if (z==0)
		for (y=1; y<Ny; y++) O[0][y]=O[0][y-1]+Nx;
	    else {
		O[z]=O[z-1]+Ny; for (y=0; y<Ny; y++) O[z][y]=O[z][y-1]+Nx;
	    }
	    ReadSliceImage(paths[z],Nx,Ny,O[z]);
	}
	while (fgets(line,LEN,stdin)!=NULL &&
	       sscanf(line,"%s %d %d %d %d %d %d",
			   dir,&x1,&y1,&z1,&x2,&y2,&z2)==7) {
	    if (x1<0 || y1<0 || z1<0 ||
		x2>=Nx || y2>=Ny || z2>=Nz ||
		x1>x2 || y1>y2 || z1>z2) Error("bad area.");

	    w=1; for (z=z2-z1; z>=10; z/=10) ++w;
	    (void)sprintf(form,"%s/%%0%dd.tif",dir,w);

	    for (z=z1; z<=z2; z++) {
		v=0;
		for (y=y1; y<=y2; y++) {
		    C[y-y1]=O[z][y]+x1;
		    for (x=x1; x<=x2; x++) if (v<O[z][y][x]) v=O[z][y][x];
		}
		for (w=1; 1<<w<=v; w<<=1) ;

		(void)sprintf(path,form,z-z1);
		StoreImageFile(path,x2-x1+1,y2-y1+1,w,C,NULL);
	    }
	}
	return 0;
}
