
#include <stdio.h>
#include <stdlib.h>
#include "cell.h"
#include "csi.h"
#include "sif.h"

extern void	Error(),ReadSliceImage();

#define LEN	1024

int	main(argc,argv)
int	argc;
char	**argv;
{
	char	**paths,form[LEN],path[LEN];
	int	Nx,Ny,Nz,x0,y0,z0,nx,ny,nz,y,len,z,x,BPS;
	Cell	**org,**new,PV;

	if (argc!=10)
	    Error("usage : si_trim orgDir nameFile x1 y1 z1 x2 y2 z2 newDir");

	paths=CheckSliceImages(argv[1],argv[2],&Nx,&Ny,&Nz,NULL);

	if ((x0=atoi(argv[3]))<0 ||
	    (y0=atoi(argv[4]))<0 ||
	    (z0=atoi(argv[5]))<0 ||
	    (nx=atoi(argv[6]))>=Nx || (nx-=(x0-1))<=0 ||
	    (ny=atoi(argv[7]))>=Ny || (ny-=(y0-1))<=0 ||
	    (nz=atoi(argv[8]))>=Nz || (nz-=(z0-1))<=0) Error("bad area.");

	if ((org=(Cell **)malloc(sizeof(Cell *)*(size_t)Ny))==NULL ||
	    (new=(Cell **)malloc(sizeof(Cell *)*(size_t)ny))==NULL ||
	    (*org=(Cell *)malloc(sizeof(Cell)*(size_t)Ny*(size_t)Nx))==NULL)
	    Error("no allocatable memory for cell.");

	for (y=1; y<Ny; y++) org[y]=org[y-1]+Nx;
	for (y=0; y<ny; y++) new[y]=org[y+y0]+x0;

	len=1; for (z=10; z<nz; z*=10) ++len;
	(void)sprintf(form,"%s/%%0%dd.tif",argv[9],len);

	for (z=0; z<nz; z++) {
	    ReadSliceImage(paths[z+z0],Nx,Ny,org);

	    PV=0;
	    for (y=0; y<ny; y++)
	    for (x=0; x<nx; x++) if (new[y][x]>PV) PV=new[y][x];

	    (void)sprintf(path,form,z);
	    for (BPS=1; 1<<BPS<=PV; BPS<<=1) ;
	    StoreImageFile(path,nx,ny,BPS,new,NULL);
	}
	return 0;
}
