
#include <stdio.h>
#include <stdlib.h>
#include "cell.h"
#include "rif_rgb.h"
#include "sif.h"
#include "sif_rgb.h"

extern void	Error();

int	main(argc,argv)
int	argc;
char	**argv;
{
	int	Nx,Ny,BPS,x1,y1,x2,y2,gray=1;
	Cell	**R,**G,**B,r,g,b;
	double	ratio;

	if (argc!=7) Error("usage : trim_RGB orgTIFF x1 y1 x2 y2 newTIFF");

	ReadImageFile_RGB(argv[1],&Nx,&Ny,&BPS,&R,&G,&B,NULL);

	if ((x1=atoi(argv[2]))<0 ||
	    (y1=atoi(argv[3]))<0 ||
	    (x2=atoi(argv[4]))>=Nx || (Nx=x2-x1+1)<=0 ||
	    (y2=atoi(argv[5]))>=Ny || (Ny=y2-y1+1)<=0) Error("bad area.");

	ratio=255.0/(double)((1<<BPS)-1);

	R+=y1; G+=y1; B+=y1;
	for (y2=0; y2<Ny; y2++) {
	    R[y2]+=x1; G[y2]+=x1; B[y2]+=x1;
	    for (x2=0; x2<Nx; x2++) {
		r=R[y2][x2]=(Cell)(ratio*(double)R[y2][x2]+0.5);
		g=G[y2][x2]=(Cell)(ratio*(double)G[y2][x2]+0.5);
		b=B[y2][x2]=(Cell)(ratio*(double)B[y2][x2]+0.5);
		if (gray) gray=r==g && r==b;
	    }
	}
	if (gray)
	    StoreImageFile(argv[6],Nx,Ny,8,R,NULL);
	else
	    StoreImageFile_RGB(argv[6],Nx,Ny,8,R,G,B,NULL);

	return 0;
}
